#include <avr/io.h>      //     -   
#include <stdio.h>       //   -
#include <avr/interrupt.h>
//===================================================================
// Fclk = 4MHz
//=========================================================================
char couScanKeys; //    
char fScanKey;
//=========================================================================

//=========================================================================
ISR(TIMER0_OVF_vect)
{
	TCNT0 = 0xc1; // 1ms for 4MHz & prescaller = 64
	if(couScanKeys)
		couScanKeys--;
	else
	{
		couScanKeys = 100; // t = 0.1 s
		fScanKey = 1;
	}
}

void initProc()
{
	// T0
	TIMSK = (1<<TOIE0); //     0
	TCNT0 = 0xc1; //(0x82 - 2 ms) (0xc1 - 1ms)
	TCCR0 = (1<<CS01)|(1<<CS00);    //  0   64

	DDRB = 0xff; // out
	DDRB &= ~(1<<0); // in
	DDRD = 0; // in
	asm("sei");
}

void initVars()
{
	couScanKeys = 100;
}
int main()
{
	initProc();
	initVars();
	
	while(1)
	{
		if(fScanKey)
		{
			fScanKey = 0;
			if(!(PIND & (1<<7)))PORTB ^= 1<<5;//left
			if(!(PIND & (1<<6)))PORTB ^= 1<<3;//right
			if(!(PINB & (1<<0)))PORTB |= 1<<4;//up
			if(!(PIND & (1<<5)))PORTB &= ~(1<<4);//down
		}
	}
	
	return 0;
}
